package it.unibz.inf.dsa1617.assignment2;

import static org.junit.Assert.*;

import org.junit.Test;

public class ArrayOfAveragesTest {

	@Test
	public void testAverage_00() {
		double[] array = {};
		double[][] expectedMatrix = {};
		double[][] actualMatrix = ArrayOfAverages.average(array);
		assertMatrixEquals(expectedMatrix, actualMatrix);
	}

	@Test
	public void testAverage_01() {
		double[] array = { 0 };
		double[][] expectedMatrix = { { 0 } };
		double[][] actualMatrix = ArrayOfAverages.average(array);
		assertMatrixEquals(expectedMatrix, actualMatrix);
	}

	@Test
	public void testAverage_02() {
		double[] array = { 0, 1 };
		double[][] expectedMatrix = { { 0, 0.5 }, { 0, 1 } };
		double[][] actualMatrix = ArrayOfAverages.average(array);
		assertMatrixEquals(expectedMatrix, actualMatrix);
	}

	@Test
	public void testAverage_03() {
		double[] array = { 0, 1, 2 };
		double[][] expectedMatrix = { { 0, 0.5, 1 }, { 0, 1, 1.5 }, { 0, 0, 2 } };
		double[][] actualMatrix = ArrayOfAverages.average(array);
		assertMatrixEquals(expectedMatrix, actualMatrix);
	}

	public static void assertMatrixEquals(double[][] expectedMatrix, double[][] actualMatrix) {

		double delta = 1e-8;

		assertEquals("expectedMatrix.length != actualMatrix.length", expectedMatrix.length, actualMatrix.length);

		int n = expectedMatrix.length;

		for (int i = 0; i < n; i++) {
			assertArrayEquals(String.format("expectedMatrix[%d] != actualMatrix[%d]", i, i), expectedMatrix[i],
					actualMatrix[i], delta);
		}

	}
}
