package it.unibz.inf.dsa1617.assignment2;

import static org.junit.Assert.*;

import org.junit.Test;

public class MaxAscentsInArraysTest {

	@Test
	public void testMaxAscentsLength_00() {
		assertEquals(0, MaxAscentsInArrays.maxAscent(new int[] {}));
	}

	@Test
	public void testMaxAscentsLength_01() {
		assertEquals(1, MaxAscentsInArrays.maxAscent(new int[] { 1 }));
	}

	@Test
	public void testMaxAscentsLength_02() {
		assertEquals(2, MaxAscentsInArrays.maxAscent(new int[] { 1, 2 }));
	}

	@Test
	public void testMaxAscentsLength_03() {
		assertEquals(2, MaxAscentsInArrays.maxAscent(new int[] { 1, 2, 1 }));
	}

	@Test
	public void testMaxAscentsLength_04() {
		assertEquals(2, MaxAscentsInArrays.maxAscent(new int[] { 1, 2, 1, 2 }));
	}

	@Test
	public void testMaxAscentsLength_05() {
		assertEquals(1, MaxAscentsInArrays.maxAscent(new int[] { 4, 3, 2, 1 }));
	}

	@Test
	public void testMaxAscentsLength_06() {
		assertEquals(2, MaxAscentsInArrays.maxAscent(new int[] { 4, 3, 2, 1, 2, 1 }));
	}

	@Test
	public void testMaxAscentsLength_07() {
		assertEquals(3, MaxAscentsInArrays.maxAscent(new int[] { 2, 3, 4, 3, 2, 1, 2, 1 }));
	}
	
	@Test
	public void testMaxAscentsLength_08() {
		assertEquals(4, MaxAscentsInArrays.maxAscent(new int[] { 2, 3, 4, 3, 2, 1, 2, 1, 2, 3, 4 }));
	}
}
